<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Dynamics_Scenario &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Sensor_Driver" href="sensor_driver.html" />
    <link rel="prev" title="Dynamics_RegularDriving" href="dynamics_regular_driving.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Dynamics_Scenario</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/dynamics_scenario.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="dynamics-scenario">
<span id="id1"></span><h1>Dynamics_Scenario<a class="headerlink" href="#dynamics-scenario" title="Link to this heading"></a></h1>
<p>This module acts as a direct implementation of external scenario actions, requested through <cite>ControlStrategies</cite> defined in the <cite>Mantle API &lt;https://gitlab.eclipse.org/eclipse/openpass/scenario_api&gt;</cite>.
As the MantleAPI is not an official standard, the module currently follows a “standard conform” interpretation based on <cite>openSCENARIO V1.1 &lt;https://www.asam.net/standards/detail/openscenario/&gt;</cite>.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Due to the nature of <strong>openPASS</strong> actions that are set by the scenario engine in one timestep, will be visible in the simulation output starting with the next timestep,
because all states are only syncronized at the end of a timestep</p>
</div>
<p>In every timestep one strategy for each MovementDomain (longitudinal and lateral) is active.
If the scenario engine sets a new strategy for a MovementDomain the previous strategy for this MovementDomain is stopped.
A strategy can also apply to both MovementDomains (meaning it is the only active strategy).
If a strategy is finished (except KeepVelocity and KeepLaneOffset which are never finished), this is reported back to the scenario engine.</p>
<section id="defaultstrategies">
<h2>DefaultStrategies<a class="headerlink" href="#defaultstrategies" title="Link to this heading"></a></h2>
<section id="keepvelocity-longitudinal">
<h3>KeepVelocity - longitudinal<a class="headerlink" href="#keepvelocity-longitudinal" title="Link to this heading"></a></h3>
<p>During this strategy the velocity is constant (same as at the time when this strategy is set).
This is the default longitudinal strategy, if no other longitudinal strategy is set.</p>
</section>
<section id="keeplaneoffset-lateral">
<h3>KeepLaneOffset - lateral<a class="headerlink" href="#keeplaneoffset-lateral" title="Link to this heading"></a></h3>
<p>During this strategy the agent will drive along the lane with a constant offset (same as at the time when this strategy is set).
This is the default lateral strategy, if no other lateral strategy is set.</p>
</section>
</section>
<section id="strategies">
<h2>Strategies<a class="headerlink" href="#strategies" title="Link to this heading"></a></h2>
<section id="followvelocityspline-longitudinal">
<h3>FollowVelocitySpline - longitudinal<a class="headerlink" href="#followvelocityspline-longitudinal" title="Link to this heading"></a></h3>
<p>A velocity spline defines a function over time of the agent velocity.
This function is a piecewise polynomial of degree 3.
This strategy will be set for SpeedActions with DynamicsShape other than step.</p>
</section>
<section id="performchangelane-lateral">
<h3>PerformChangeLane - lateral<a class="headerlink" href="#performchangelane-lateral" title="Link to this heading"></a></h3>
<p>This strategy will have the agent switching lanes while keeping a constant longitudinal velocity (in s direction).
It will be set for LaneChangeActions where the target lane is not the current lane.
At the momement only DynamicsShape sinusoidal and DynamicsDimension distance or time is supported.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>In the current implementation both movement domains are touched, even if a longitudinal movement controller is active.
This means that the velocity of the longitudinal is ignored while the lane change is executed.
This may result in a jump of the velocity at the end of the lane change.</p>
</div>
</section>
<section id="followtrajectory-both">
<h3>FollowTrajectory - both<a class="headerlink" href="#followtrajectory-both" title="Link to this heading"></a></h3>
<p>A trajectory defines the position and orientation of the agent at defined times.
If a timestep lies between the trajectory points the position is linearly interpolated.
This strategy will be set for FollowTrajectoryActions.
TrajectoryFollowingMode is not supported and the agent will always strictly adhere to the trajectory.</p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="dynamics_regular_driving.html" class="btn btn-neutral float-left" title="Dynamics_RegularDriving" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="sensor_driver.html" class="btn btn-neutral float-right" title="Sensor_Driver" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>